org.eclipse.jgit.util

## Class QuotedString

- java.lang.Object
- - org.eclipse.jgit.util.QuotedString

Direct Known Subclasses:
  QuotedString.BourneStyle, QuotedString.GitPathStyle

    public abstract class QuotedString
    extends Object

Utility functions related to quoted string handling.

### Nested Class Summary

Nested Classes
`static class` `QuotedString.BourneStyle` Quoting style used by the Bourne shell.
`static class` `QuotedString.BourneUserPathStyle` Bourne style, but permits `~user` at the start of the string.
`static class` `QuotedString.GitPathStyle` Quoting style that obeys the rules Git applies to file names

### Field Summary

Fields
`static QuotedString.BourneStyle` `BOURNE` Quoting style used by the Bourne shell.
`static QuotedString.BourneUserPathStyle` `BOURNE_USER_PATH` Bourne style, but permits `~user` at the start of the string.
`static QuotedString.GitPathStyle` `GIT_PATH` Quoting style that obeys the rules Git applies to file names

### Constructor Summary

Constructors
Constructor and Description
`QuotedString()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`abstract String` `dequote(byte[] in, int offset, int end)` Decode a previously quoted input, scanning a UTF-8 encoded buffer.
`String` `dequote(String in)` Clean a previously quoted input, decoding the result via UTF-8.
`abstract String` `quote(String in)` Quote an input string by the quoting rules.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### GIT_PATH

    public static final QuotedString.GitPathStyle GIT_PATH

Quoting style that obeys the rules Git applies to file names

#### BOURNE

    public static final QuotedString.BourneStyle BOURNE

Quoting style used by the Bourne shell.

Quotes are unconditionally inserted during `quote(String)`. This protects shell meta-characters like `$` or `~` from being recognized as special.

#### BOURNE_USER_PATH

    public static final QuotedString.BourneUserPathStyle BOURNE_USER_PATH

Bourne style, but permits `~user` at the start of the string.

### Constructor Detail

#### QuotedString

    public QuotedString()

### Method Detail

#### quote

    public abstract String quote(String in)

Quote an input string by the quoting rules.

If the input string does not require any quoting, the same String reference is returned to the caller.

Otherwise a quoted string is returned, including the opening and closing quotation marks at the start and end of the string. If the style does not permit raw Unicode characters then the string will first be encoded in UTF-8, with unprintable sequences possibly escaped by the rules.

Parameters:
  `in` - any non-null Unicode string.
Returns:
  a quoted string. See above for details.

#### dequote

    public String dequote(String in)

Clean a previously quoted input, decoding the result via UTF-8.

This method must match quote such that:

     a.equals(dequote(quote(a)));

is true for any `a`.

Parameters:
  `in` - a Unicode string to remove quoting from.
Returns:
  the cleaned string.
See Also:
  `dequote(byte[], int, int)`

#### dequote

    public abstract String dequote(byte[] in,
                                   int offset,
                                   int end)

Decode a previously quoted input, scanning a UTF-8 encoded buffer.

This method must match quote such that:

     a.equals(dequote(Constants.encode(quote(a))));

is true for any `a`.

This method removes any opening/closing quotation marks added by `quote(String)`.

Parameters:
  `in` - the input buffer to parse.
  `offset` - first position within `in` to scan.
  `end` - one position past in `in` to scan.
Returns:
  the cleaned string.